#version 430 core
//
//	Copyright (c) 2015, Kin-Ming Wong and Tien-Tsin Wong
//  All rights reserved.
//
//	Redistribution and use in source and binary forms, with or without modification,
//	are permitted provided that the following conditions are met:
//
//	Redistributions of source code must retain the above copyright notice,
//	this list of conditions and the following disclaimer.
//
//	Redistributions in binary form must reproduce the above copyright notice,
//	this list of conditions and the following disclaimer in the documentation
//	and/or other materials provided with the distribution.
//
//	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
//	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//	IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
//	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
//	BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//	LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
//	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
//	OF THE POSSIBILITY OF SUCH DAMAGE.
//
//	Please cite our original article
//	'Edge-preserving smoothing filter for particle-based rendering'
//	in Game Engine Gems 3 if you use any part of the following code.
//
layout(local_size_x = 1024) in;
layout(binding = 0, rgba32f)  readonly uniform image2D inImage;
layout(binding = 1, rgba32f) writeonly uniform image2D outImage;

shared vec3 shData[gl_WorkGroupSize.x * 2];

void main() {

	uint	id = gl_LocalInvocationID.x;
	ivec2	texCoord = ivec2(id, gl_WorkGroupID.x);

	//	Co-operative read in
	vec3 pixel = imageLoad(inImage, texCoord).rgb;

	pixel = pixel * pixel;

	//	Co-operative write back
	imageStore(outImage, texCoord, vec4(pixel.rgb, 1.0));

}
